#
# This is the makefile that sets up a common configuration for
# different subdirectories of this project.  It should be included
# after OBJS is defined (if necessary), but before your first target.
# You must also define TOPDIR to be the relative path to the top-level
# directory before including this file as follows:
#
#     include $(TOPDIR)/common.mk
#

LIBRARY_BASE_NAME = event_loop
LIBRARY = $(TOPDIR)/lib/lib$(LIBRARY_BASE_NAME).a

CGUL=$(TOPDIR)/../cgul

#EXTRA_WARNINGS = -Wunused-function \
#                 -Wunused-parameter \
#                 -Wunused-value \
#                 -Wunused-variable

CPPFLAGS = -I$(TOPDIR)/include -I$(CGUL)/include
CFLAGS = $(C99FLAGS) $(DCFLAGS) -Wall $(EXTRA_WARNINGS) $(PROFILE_FLAGS)
CXXFLAGS= $(CFLAGS)

LDFLAGS = $(PROFILE_FLAGS) \
          -L$(TOPDIR)/lib \
          -L$(CGUL)/lib \
          $(ELF2FLT)

LDLIBS = -l$(LIBRARY_BASE_NAME) -lcgul
ARFLAGS = cruU

# We do not need the .o files to say on the system.
$(LIBRARY)(%.o): %.o
	$(AR) $(ARFLAGS) $(LIBRARY) $<
	@$(RM) $<


# We need to alter the compile rule in order to post-process
# the automatically generated dependencies file.  (I would use
# "perl -p -i -e" below but it complains on windows).
#

# You can switch to build that uses the C++ compiler by issuing the
# following command:
#
#     make c++
#
ifdef CXXBUILD
CC = $(CXX)
endif

%.o: %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -MMD -o $@ -c $<
	@if [ "$@" = "main.o" ] ; then \
            mv $*.d .$*.d ;\
        else \
            sed -e 's|^$@:|$(LIBRARY)($@):|' $*.d > .$*.d && rm $*.d ;\
        fi

ifdef OBJS
    # Notice the leading '.' on the dependencies files.
    DEPS = $(patsubst %,.%,$(OBJS:%.o=%.d))
    -include $(DEPS)
endif
